//
// responsive (media-queries)
//

// variables
$breakpoints: (
  xs:  0,
  sm:  640px,
  md:  960px,
  lg:  1280px,
  xl:  1600px,
 xxl:  1920px
) !default;

$offcanvas: map-get($breakpoints, "sm");

// mixin
@mixin mq($breakpoint) {
  @if map-has-key($breakpoints, $breakpoint) {
    @media (min-width: #{map-get($breakpoints, $breakpoint)}) {
      @content;
    }
  }

  @elseif type-of($breakpoint) == number {
    @media (min-width: #{$breakpoint}) {
      @content;
    }
  }

  @else {
    @content;
  }
}

// breakpoint-min
@mixin mq-min($breakpoint) {
  @if map-has-key($breakpoints, $breakpoint) {
    @media (min-width: #{map-get($breakpoints, $breakpoint)}) {
      @content;
    }
  }

  @elseif type-of($breakpoint) == number {
    @media (min-width: #{$breakpoint}) {
      @content;
    }
  }

  @else {
    @content;
  }
}

// breakpoint-max
@mixin mq-max($breakpoint) {
  @if map-has-key($breakpoints, $breakpoint) {
    @media (max-width: #{map-get($breakpoints, $breakpoint) - 0.02px }) {
      @content;
    }
  }

  @elseif type-of($breakpoint) == number {
    @media (max-width: #{$breakpoint - 0.02px }) {
      @content;
    }
  }

  @else {
    @content;
  }
}

// breakpoint-between
@mixin mq-between($breakpoint-min, $breakpoint-max) {

  @if map-has-key($breakpoints, $breakpoint-min) and map-has-key($breakpoints, $breakpoint-max) {
    @media (min-width: #{map-get($breakpoints, $breakpoint-min)}) and (max-width: #{map-get($breakpoints, $breakpoint-max) - .02px }) {
      @content;
    }
  }

  @elseif map-has-key($breakpoints, $breakpoint-min) and type-of($breakpoint-max) == number {
    @media (min-width: #{map-get($breakpoints, $breakpoint-min)}) and (max-width: #{$breakpoint-max - .02px }) {
      @content;
    }
  }

  @elseif type-of($breakpoint-min) == number and map-has-key($breakpoints, $breakpoint-max) {
    @media (min-width: #{$breakpoint-min}px) and (max-width: #{map-get($breakpoints, $breakpoint-max) - .02px }) {
      @content;
    }
  }

  @elseif type-of($breakpoint-min) == number and type-of($breakpoint-max) == number {
    @media (min-width: #{$breakpoint-min}px) and (max-width: #{$breakpoint-max - .02px }) {
      @content;
    }
  }

  @else {
    @content;
  }
}
